﻿package script{

	/*
	 * AINE - Accelerated Interactive Narrator Engine
	 * @version 0.4.2 ALPHA
	 * @author Daniel Svejstrup Christensen
	 * @see http://www.drakkashi.com/aine/ for updates
	 * This software is released under the MIT License <http://www.opensource.org/licenses/mit-license.php>
	 * Copyright © 2014 Drakkashi.com
	 */

	import flash.display.Bitmap;
	import flash.events.Event;

	public class Character extends Person{

		private static var list:Array = new Array();

		private var bitmap:Bitmap;
											
		public function Character(instance:String){
			this.instance = instance;
			setName(instance);
			addEventListener(Event.ADDED_TO_STAGE, showImage);
			addEventListener(Event.REMOVED_FROM_STAGE, hideImage);
			list.push(this);
		}

		override public function setImage(str:String):void{
			super.setImage(str);
			if (bitmap)
				showImage();
		}

		public function showImage(e:Event = null):void{
			hideImage();
			bitmap = Image.getImage(image);
			if (bitmap){
				if (bitmap.width / 72.6 > bitmap.height / 92.6){
					bitmap.height = bitmap.height/bitmap.width*72.6;
					bitmap.width = 72.6;
				}
				else{
					bitmap.width = bitmap.width/bitmap.height*92.6;
					bitmap.height = 92.6;
				}
	
				bitmap.x = 3.7 + (72.6-bitmap.width)/2;
				bitmap.y = 3.7 + (92.6-bitmap.height)/2;
				imageHolder.addChild(bitmap);
			}
		}

		public function hideImage(e:Event = null):void{
			if (bitmap && bitmap.parent)
				bitmap.parent.removeChild(bitmap);
			bitmap = null;
		}

		public function setCurrent(room:Room):void{
			remove();
			current = room;
		}

		public function remove():void{
			if (current)
				current.removeCharacter(this);
		}

		public function moveTo(... args):void{
			var room:Room = (toClass(args[0]) == Room ? args[0] : Room.getRoom(args[0]));

			if (room)
				room.giveCharacter(this);
		}

		override public function getMethods():Array{
			return super.getMethods().concat(new Array("remove"));
		}

		public static function getCharacter(str:String):Character{
			for (var i:int = 0; i < list.length; i++)
				if (list[i].instance == str)
					return list[i];
			return null;
		}

		public static function count():int{
			return list.length;
		}

		public static function getTags():Array{
			var tags:Array = new Array();

			for (var i:int = 0; i < list.length; i++)
				tags.push(list[i].getInstance());
			return tags;
		}
	}
}