﻿package script{

	/*
	 * AINE - Accelerated Interactive Narrator Engine
	 * @version 0.4.2 ALPHA
	 * @author Daniel Svejstrup Christensen
	 * @see http://www.drakkashi.com/aine/ for updates
	 * This software is released under the MIT License <http://www.opensource.org/licenses/mit-license.php>
	 * Copyright © 2014 Drakkashi.com
	 */

	public class Container extends _Object{

		protected var itemList:Array = new Array();

		public function giveItem(... args):void{
			var item:Item = (toClass(args[0]) == Item ? args[0] : Item.getItem(args[0]));

			if (item && itemList.indexOf(item) < 0){
				item.setContainer(this);
				itemList.push(item);
			}
		}

		public function takeItem(item:Item):void{
			if (item && hasItem(item))
				itemList.splice(itemList.indexOf(item),1);
		}

		public function hasItem(... args):Boolean{
			var item:Item = (toClass(args[0]) == Item ? args[0] : Item.getItem(args[0]));
			return item && itemList.indexOf(item) >= 0;
		}

		public function getItemList():Array{
			return cloneArray(itemList);
		}

		override public function setVar(id:String,val:*, ... args):String{
			if (id == "items"){
				if (toClass(val) == Item || toClass(val) == Array){

					if (toClass(val) == Array){
						var list:Array = val;
						for (var i:int = 0; i < list.length; i++){
							if (list[i] && toClass(list[i]) != Item){
								return 'Invalid entry in list. All entries has to be a Item object.';
								break;
							}
						}
						
						if (i >= list.length)
							for (i = 0; i < list.length; i++)
								if (list[i])
									this.giveItem(list[i]);
					}
					else
						this.giveItem(val);
				}
				else if (val)
					return String(this.getClass()).toUpperCase()+' property "items" has to be an Item object or a List.';
			}
			else
				return super.setVar(id,val);
			return null;
		}

		override public function getMethods():Array{
			return super.getMethods().concat(new Array("giveItem","hasItem"));
		}
	}
}