﻿package script{

	/*
	 * AINE - Accelerated Interactive Narrator Engine
	 * @version 0.4.2 ALPHA
	 * @author Daniel Svejstrup Christensen
	 * @see http://www.drakkashi.com/aine/ for updates
	 * This software is released under the MIT License <http://www.opensource.org/licenses/mit-license.php>
	 * Copyright © 2014 Drakkashi.com
	 */
	import flash.utils.getQualifiedClassName;
	import flash.utils.getDefinitionByName;

	public class Decipher{

		public static function importObjects(dataList:Array,dirList:Array = null):void {
			var idList:Array = new Array("Item","Player","Character","Room"),
				objList:Array = new Array(new Array,new Array,new Array,new Array);

			removeComments(dataList);

			for (var i:int = 0; i < dataList.length; i++){
				var beg:int = 0,
					nameList:Array = new Array();

				while(beg < dataList[i].length){
					var match:Array = dataList[i].substr(beg).match(/[\{\}\[\]\"\'\:\n]/),
						line:int = countLines(dataList[i].substr(0,beg))+1,
						id:String = null,
						instance:String = null,
						end:int;

					if (!match){
						match = new Array("");
						end = int.MAX_VALUE;
					}
					else
						end = dataList[i].indexOf(match[0],beg);

					var subStr:String = trim(dataList[i].substring(beg,end));

					if (!(subStr.length == 0 && match[0] == "\n")){
						if (!(match[0] == '"' || match[0] == "'") && subStr.length > 0 && idList.indexOf(subStr) < 0){
							Output.err('Invalid indentifier.',dirList[i],line);
						}
						else
							id = subStr;
	
						if (match[0] == ":"){
							if (subStr.length == 0)
								Output.err("Expected identifier before colon.",dirList[i],line);
	
							beg = end+1;
							match = dataList[i].substr(beg).match(/[\{\}\[\]\"\'\:\n]/);
	
							if (!match){
								match = new Array("");
								end = int.MAX_VALUE;
							}
							else
								end = dataList[i].indexOf(match[0],beg);
	
							subStr = trim(dataList[i].substring(beg,end));
	
							if (!(match[0] == '"' || match[0] == "'") && subStr.length > 0){
								if (subStr.length != subStr.replace(/\s+/g, "").length)
									Output.err('Instance name most be one word.',dirList[i],line);
								else if (subStr.length != subStr.replace(/[^a-zA-Z_0-9\$]/g, "").length)
									Output.err('Instance name may only contain letters a-z, the signs _$ and numbers',dirList[i],line);
								else if (!isNaN(Number(subStr.charAt())))
									Output.err('Instance name may not begin with a number.',dirList[i],line);
								else if (isReserved(instance))
									Output.err('"' + instance + '" is a reserved and may not be used as instance name.',dirList[i],line);
								else if (subStr == "player" && id != "Player")
									Output.err('"player" is a reserved instance name for the Player object.',dirList[i],line);
								else if (id){
									var b:Boolean = true;
									for (var j:int = 0; j < objList.length; j++)
										for each (var entry:Array in objList[j])
											if (entry[0] == subStr){
												if (j == idList.indexOf(id))
													instance = subStr;
												else
													Output.err('Duplicate instance name of objects of different types.',dirList[i],line);
												b = false;
												break;
											}

									if (b)
										instance = subStr;
								}
								else
									instance = subStr;
							}
							else if (!(match[0] == '"' || match[0] == "'") && subStr.length == 0){
								if (id == "Player")
									instance = "player";
								else if (id)
									Output.err('Instance name of ' + id +  ' object cannot be null.',dirList[i],line);
							}
							
							if (match[0].length == 0 || match[0] == "\n" || match[0] == "{"){
								if (id && instance){
									subStr = null;
									if (firstChar(dataList[i].substr(dataList[i].indexOf(match[0],beg))) == "{"){
										
										match[0] = "{";
										beg = dataList[i].indexOf("{",beg);
										end = segmentEnd(dataList[i].substr(beg));
	
										if (end >= 0)
											subStr = dataList[i].substring(beg+1,beg+end);
									}

									if (nameList.indexOf(instance) >= 0)
										Output.warn("Duplicate instance name.",dirList[i],line);
									else
										nameList.push(instance);
									objList[idList.indexOf(id)].push(new Array(instance,subStr,dirList[i],line));
								}
							}
							else if (match[0] == ":")
								Output.err("Expected identifier before colon.",dirList[i],line);
							else if (match[0] == "[")
								Output.err("Expected leftbrace or nothing after instance name.",dirList[i],line);
							else if (match[0] == '"' || match[0] == "'")
								Output.err("Instance name cannot be or contain a string.",dirList[i],line);
							else if (match[0] == "}")
								Output.err("Expected leftbrace before rightbrace.",dirList[i],line);
							else if (match[0] == "]")
								Output.err("Expected leftbracket before rightbracket.",dirList[i],line);
						}
						else if (match[0].length == 0 || match[0] == "\n"){
							if (subStr.length > 0)
								Output.err("Expected colon after identifier.",dirList[i],line);
						}
						else if (match[0] == "{" || match[0] == "["){
							if(subStr.length == 0)
								Output.err("Expected identifier before " + (match[0] == "{" ? "leftbrace." : "leftbracket."),dirList[i],line);
							else
								Output.err("Expected colon after identifier.",dirList[i],line);
						}
						else if (match[0] == '"' || match[0] == "'")
							Output.err("Identifier cannot be or contain a string.",dirList[i],line);
						else if (match[0] == "}")
							Output.err("Expected leftbrace before rightbrace.",dirList[i],line);
						else if (match[0] == "]")
							Output.err("Expected leftbracket before rightbracket.",dirList[i],line);

						while(match && match.length > 0 && match[0].length > 0 && match[0] != "\n"){
							if (match[0] == "'" || match[0] == '"'){
								beg = dataList[i].indexOf(match[0],beg);
								end = dataList[i].indexOf(match[0],beg+1);
		
								if (end >= 0)
									beg = end+1;
								else
									beg = int.MAX_VALUE;
							}
							else if (match[0] == "["){
								beg = dataList[i].indexOf("[",beg);
								end = segmentEnd(dataList[i].substr(beg),"[","]");
	
								if (end >= 0)
									beg = beg+end+1;
								else{
									Output.err('Expected rightbracket before end of file.',dirList[i],line);
									beg = int.MAX_VALUE;
								}
							}
							else if (match[0] == "{"){
								beg = dataList[i].indexOf("{",beg);
								end = segmentEnd(dataList[i].substr(beg));
	
								if (end >= 0)
									beg = beg+end+1;
								else{
									Output.err('Expected rightbrace before end of file.',dirList[i],line);
									beg = int.MAX_VALUE;
								}
							}
							else
								beg = dataList[i].indexOf(match[0],beg)+1;
	
							match = dataList[i].substr(beg).match(/[\{\}\[\]\"\'\:\n]/);
						}
					}

					if (!match || match[0].length == 0)
						beg = int.MAX_VALUE;
					else if (match[0] == "\n")
						beg = dataList[i].indexOf("\n",beg)+1;
				}
			}

			for each (var player:Array in objList[idList.indexOf("Player")])
				new Player(player[0]);
			for each (var room:Array in objList[idList.indexOf("Room")])
				if (!Room.getRoom(room[0]))
					new Room(room[0]);
			for each (var char:Array in objList[idList.indexOf("Character")])
				if (!Character.getCharacter(char[0]))
					new Character(char[0]);
			for each (var item:Array in objList[idList.indexOf("Item")])
				if (!Item.getItem(item[0]))
					new Item(item[0]);

			if (Room.count() == 0){
				new Room();
				Output.warn("Missing Room object. Creating default Room.");
			}

			if (!Player.getPlayer()){
				new Player();
				Output.warn("Missing Player object. Creating default Player.");
			}

			readObjData(objList);

			if (!Room.getStartingRoom()){
				Room.setStartingRoom();
				Output.warn("Missing starting room. Assigning default starting room.");
			}
		}

		private static function readObjData(objList:Array):void {
			for (var i:int = 0; i < objList.length; i++)
				for each (var obj:Array in objList[i])
					if (obj[1]){
						var beg:int = 0,
							object:_Object = _Object.getObject(obj[0]);

						while(beg < obj[1].length){
							var match:Array = obj[1].substr(beg).match(/\=\>|[\{\}\[\]\"\'\:\n\=]/),
								line:int = countLines(obj[1].substr(0,beg))+obj[3],
								id:String = null,
								val:String = null,
								end:int;
							if (!match){
								match = new Array("");
								end = int.MAX_VALUE;
							}
							else
								end = obj[1].indexOf(match[0],beg);

							var subStr:String = trim(obj[1].substring(beg,end));

							if (!(subStr.length == 0 && match[0] == "\n")){
								if (!(match[0] == '"' || match[0] == "'") && subStr.length > 0){
									if (subStr.length != subStr.replace(/\s+/g, "").length)
										Output.err('Identifier cannot contain whitespace.',obj[2],line);
									else if (subStr.length != subStr.replace(/[^a-zA-Z_0-9\$]/g, "").length)
										Output.err('Identifier can only contain letters a-z, the signs _$ and numbers',obj[2],line);
									else if (!isNaN(Number(subStr.charAt())))
										Output.err('Identifier cannot begin with a number.',obj[2],line);
									else if (isReserved(id))
										Output.err('"' + id + '" is reserved and may not be used as property identifier.',obj[2],line);
									else
										id = subStr;
								}

								if (match[0] == ":" || ((match[0] == "=>" || match[0] == "=") && Nav.pathIndex(id) >= 0 && object.getClass() == Room)){
									if (subStr.length == 0)
										Output.err("Expected identifier before colon.",obj[2],line);

									var isConnected:Boolean = match[0] != "=>";

									beg = end+match[0].length;
									match = obj[1].substr(beg).match(/[\{\[\"\'\:\n]/);
			
									if (!match){
										match = new Array("");
										end = int.MAX_VALUE;
									}
									else
										end = obj[1].indexOf(match[0],beg);

									if (match[0] == '"' || match[0] == "'"){
										if (firstChar(obj[1].substring(beg)) == match[0]){
											beg = end;
											end = obj[1].indexOf(match[0],beg+1);
											val = obj[1].substring(beg+1,end);
											var index:int = obj[1].substr(end+1).indexOf("\n");

											if (index < 0)
												index = int.MAX_VALUE;
											
											if (trim(obj[1].substr(end+1,index)).length == 0){
												// Is String
												Output.err(object.setVar(id,val),obj[2],line);
											}
											else
												Output.err("Unable to read syntax.",obj[2],line);
										}
										else
											Output.err("Unable to read syntax.",obj[2],line);
									}
									else if (match[0] == '{'){
										// IS OBJECT OP
										Output.err("Unable to read syntax.",obj[2],line);
										Output.warn("Object operators are not currently finished.",obj[2],line);
									}
									else if (match[0] == '['){
										if (firstChar(obj[1].substring(beg)) == '['){
											beg = end;
											end = obj[1].indexOf(']',beg+1);
											var list:Array = strToList(obj[1].substring(beg+1,end),obj[2],line);
											
											if (list)
												Output.err(object.setVar(id,list),obj[2],line);
										}
										else
											Output.err("Unable to read syntax.",obj[2],line);
									}
									else if (match[0] != ':'){
										val = trim(obj[1].substring(beg,end));
										if (val.length != val.replace(/\s+/g, "").length){
											Output.err("Unable to read syntax.",obj[2],line);
											val = null;
										}
										else if (val && val.length > 0){
											if (val == "null"){
												// Is null
												Output.err(object.setVar(id,null),obj[2],line);
											}
											else if (val == "true" || val == "false"){
												// Is boolean
												Output.err(object.setVar(id,val == "true"),obj[2],line);
											}
											else if (!isNaN(Number(val))){
												// Is number
												Output.err(object.setVar(id,Number(val)),obj[2],line);
											}
											else{
												var objVal:_Object = _Object.getObject(val);
												if (objVal){
													// Is instance
													Output.err(object.setVar(id,objVal,isConnected),obj[2],line);
												}
												else
													Output.err('Undefined instance "' + val + '".',obj[2],line);
											}
										}
									}
									else{
										Output.err("Expected identifier before colon.",obj[2],line);
									}

								}
								else if (match[0] == "=>" || match[0] == "="){
									if (Nav.pathIndex(id) < 0){
										Output.err("Invalid path identifier.",obj[2],line);
										if (match[0] == "=")
											Output.warn("When assigning initial values to an object the assign operator is only allowed for assigning navigation between rooms. Use colon between identifier and value of other properties.",obj[2],line);
									}
									else
										Output.err("Initial navigation between rooms can only be assigned in Room objects.",obj[2],line);
								}
								else if (match[0].length == 0 || match[0] == "\n"){
									if (subStr.length > 0)
										Output.err("Expected colon after identifier.",obj[2],line);
								}
								else if (match[0] == "{" || match[0] == "["){
									if(subStr.length == 0)
										Output.err("Expected identifier before " + (match[0] == "{" ? "leftbrace." : "leftbracket."),obj[2],line);
									else
										Output.err("Expected colon after identifier.",obj[2],line);
								}
								else if (match[0] == '"' || match[0] == "'")
									Output.err("Identifier cannot be or contain a string.",obj[2],line);
								else if (match[0] == "}")
									Output.err("Expected leftbrace before rightbrace.",obj[2],line);
								else if (match[0] == "]")
									Output.err("Expected leftbracket before rightbracket.",obj[2],line);
			
								while(match && match.length > 0 && match[0].length > 0 && match[0] != "\n"){
									if (match[0] == "'" || match[0] == '"'){
										beg = obj[1].indexOf(match[0],beg);
										end = obj[1].indexOf(match[0],beg+1);
				
										if (end >= 0)
											beg = end+1;
										else
											beg = int.MAX_VALUE;
									}
									else if (match[0] == "["){
										beg = obj[1].indexOf("[",beg);
										end = segmentEnd(obj[1].substr(beg),"[","]");
			
										if (end >= 0)
											beg = beg+end+1;
										else{
											Output.err('Expected rightbracket before end of file.',obj[2],line);
											beg = int.MAX_VALUE;
										}
									}
									else if (match[0] == "{"){
										beg = obj[1].indexOf("{",beg);
										end = segmentEnd(obj[1].substr(beg));
			
										if (end >= 0)
											beg = beg+end+1;
										else{
											Output.err('Expected rightbrace before end of file.',obj[2],line);
											beg = int.MAX_VALUE;
										}
									}
									else
										beg = obj[1].indexOf(match[0],beg)+1;

									match = obj[1].substr(beg).match(/[\{\[\"\'\:\n]/);
								}
							}

							if (!match || match[0].length == 0)
								beg = int.MAX_VALUE;
							else if (match[0] == "\n")
								beg = obj[1].indexOf("\n",beg)+1;
						}
					}

		}

		private static function countLines(str:String):int{
			return str.match(new RegExp("\n","/g")).length;
		}

		private static function strToList(str:String,file:String,line:int):Array{
			var list:Array = new Array(),
				subLists:Array = new Array(new Array(),new Array()),
				match:Array,
				end:int,
				index:int = 0,
				beg:int = 0;

			while((match = str.substr(beg).match(/(\"|\'|\,)/)) && match[0].length > 0){
				end = str.indexOf(match[0],beg);
				if (match[0] == ","){
					subLists[0].push(trim(str.substring(index,end)));
					subLists[1].push(countLines(str.substr(0,index)));
					beg = end+1;
					index = beg;
				}
				else{
					end = str.indexOf(match[0],end+1);

					if (end >= 0)
						beg = end+1;
					else
						beg = int.MAX_VALUE;
				}
			}
			subLists[0].push(trim(str.substr(index)));
			subLists[1].push(countLines(str.substr(0,index))+1);

			for (var i:int = 0; i < subLists[0].length; i++){
				var char = firstChar(subLists[0][i]);
					if (char == "'" || char == '"'){
						var subStr:String = subLists[0][i].substring(1,subLists[0][i].indexOf(char,1));
						if (subStr.length < subLists[0][i].length -2){
							Output.err("Unable to read syntax.",file,line+subLists[1][i]);
							break;
						}
						else
							list.push(subStr);
					}
					else if (subLists[0][i].length == 0)
						list.push(null);
					else if (subLists[0][i] == "true" || subLists[0][i] == "false")
						list.push(subLists[0][i] == "true");
					else if (!isNaN(Number(subLists[0][i])))
						list.push(Number(subLists[0][i]));
					else{
						list.push(_Object.getObject(subLists[0][i]));
						if (!list[list.length-1]){
							Output.err("Unable to read syntax.",file,line+subLists[1][i]);
						break;
					}
				}
			}

			if (i == subLists[0].length)
				return list;
			return null;
		}

		private static function removeComments(dataList:Array):void{
			var match:Array,
				index:int,
				end:int;

			for (var i:int = 0; i < dataList.length; i++){
				var beg:int = 0;

				while((match = dataList[i].substr(beg).match(/(\"|\'|\/\/|\/\*)/)) && match[0].length > 0){
					index = dataList[i].indexOf(match[0],beg);
					if (match[0] == "//" || match[0] == "/*"){
						if (match[0] == "//")
							match = dataList[i].match(/\/\/([^]*?)\n/g);
						else
							match = dataList[i].match(/\/\*([^]*?)\*\//g);

						if (match.length > 0){
							end = dataList[i].indexOf(match[0],index)+match[0].length;
							var subStr:String = "";
							for (var j:int = countLines(match[0]); j > 0; j--)
								subStr += "\n";
							dataList[i] = dataList[i].substr(0,index) + subStr + dataList[i].substr(end);
							beg = index;
						}
						else{
							dataList[i] = dataList[i].substr(0,index);
							beg = int.MAX_VALUE;
						}
					}
					else{
						end = dataList[i].indexOf(match[0],index+1);

						if (end >= 0)
							beg = end+1;
						else
							beg = int.MAX_VALUE;
					}
				}
				dataList[i] = dataList[i].replace(/\s+$/g, "");
			}
		}

		private static function isReserved(str:String):Boolean {
			/*
			 * LOOK FOR PROPERTIES, SYNTAX, METHODS AND FUNCTIONS
			 */
			return new Array("Item","Player","Character","Room","if","else","null").indexOf(str) >= 0;
		}

		private static function trim(str:String):String{
			return (str ? str.replace(/^\s+|\s+$/g, "") : "");
		}

		private static function startsWith(str:String,pattern:String):Boolean{
			str = trim(str);
			if(str.substring(0,pattern.length) == pattern)
				return true;
			return false;
		}

		private static function firstChar(str:String):String{
			return trim(str).charAt();
		}

		private static function toClass(instance:*):Class{
			if (!instance)
				return null;
			return Class(getDefinitionByName(getQualifiedClassName(instance)));
		}

		private static function segmentEnd(str:String,char1:String = "{",char2:String = "}"):int{
			var index:int = 0,
				subStr:String = str.slice(str.indexOf(char1)+1,str.indexOf(char2));

			while (subStr.split(char1).length > subStr.split(char2).length && index >= 0){
				index = str.indexOf(char2, index+1);
				subStr = str.slice(str.indexOf(char1)+1,str.indexOf(char2, index+1));
			}
			if (str.indexOf(char2) < 0 && str.indexOf(char1) >= 0 || index < 0)
				return -1;
			return str.indexOf(char2, index+1);
		}
	}
}