﻿package script{

	/*
	 * AINE - Accelerated Interactive Narrator Engine
	 * @version 0.4.2 ALPHA
	 * @author Daniel Svejstrup Christensen
	 * @see http://www.drakkashi.com/aine/ for updates
	 * This software is released under the MIT License <http://www.opensource.org/licenses/mit-license.php>
	 * Copyright © 2014 Drakkashi.com
	 */

	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;

	public class Engine extends MovieClip{

		private static var gameTitle:String,
						   stageRef:Stage;

		public function Engine(){
			gotoAndStop(0);
			var preloader:Preloader = new Preloader(this.loaderInfo);
			preloader.addEventListener("importAssets", loadAssets);
			preloader.addEventListener(Event.REMOVED_FROM_STAGE, preloaderComplete);
			preloader.x = (800-preloader.width)/2;
			preloader.y = (495-preloader.height)/2;
			stageRef = stage;
			stageRef.addChild(preloader);
		}

		private function loadAssets(e:Event):void {
			e.currentTarget.removeEventListener("importAssets", loadAssets);
			gotoAndPlay(2);
		}

		private function preloaderComplete(e:Event):void {
			e.currentTarget.removeEventListener(Event.REMOVED_FROM_STAGE, preloaderComplete);
			startGame();
		}

		private static function startGame():void {
			new Interface();
		}

		public static function setTitle(str:String):void {
			if (!gameTitle)
				gameTitle = getValidTitle(str);
		}

		public static function getTitle():String {
			return gameTitle;
		}

		public static function getValidTitle(str:String):String{
			return str.replace(/(\s|~|%|&|;|:|"|'|,|<|>|?|#)/g, "").toLowerCase();
		}

		public static function getStage():Stage {
			return stageRef;
		}
	}
}