﻿package script{

	/*
	 * AINE - Accelerated Interactive Narrator Engine
	 * @version 0.4.2 ALPHA
	 * @author Daniel Svejstrup Christensen
	 * @see http://www.drakkashi.com/aine/ for updates
	 * This software is released under the MIT License <http://www.opensource.org/licenses/mit-license.php>
	 * Copyright © 2014 Drakkashi.com
	 */

	public class Item extends _Object{

		private static var list:Array = new Array();

		private var container:Container;

		public function Item(instance:String){
			this.instance = instance;
			setName(instance);
			x = 7.75;
			list.push(this);
		}

		public function moveTo(... args):void{
			var obj:_Object = (toClass(args[0]) == String ? _Object.getObject(args[0]) : args[0]);
			
			if (obj && obj.getClass() != Item)
				(obj as Container).giveItem(this);
		}

		public static function count():int{
			return list.length;
		}

		override public function setName(str:String):void{
			super.setName(str);
			txt_name.text = str;
		}

		public function setContainer(container:Container):void{
			remove();
			this.container = container;
		}

		public function remove():void{
			if (container)
				container.takeItem(this);
		}

		public function currentRoom():Container{
			if (container && container.getClass() == Room)
				return container;
			if (container && container.getClass() == Player)
				return Room.getCurrent();
			if (container)
				return (container as Character).currentRoom();
			return null;
		}

		public static function getItem(str:String):Item{
			for (var i:int = 0; i < list.length; i++)
				if (list[i].instance == str)
					return list[i];
			return null;
		}

		override public function getMethods():Array{
			return super.getMethods().concat(new Array("currentRoom","moveTo","remove"));
		}

		public static function getTags():Array{
			var tags:Array = new Array();

			for (var i:int = 0; i < list.length; i++)
				tags.push(list[i].getInstance());
			return tags;
		}
	}
}