﻿package script{

	/*
	 * AINE - Accelerated Interactive Narrator Engine
	 * @version 0.4.2 ALPHA
	 * @author Daniel Svejstrup Christensen
	 * @see http://www.drakkashi.com/aine/ for updates
	 * This software is released under the MIT License <http://www.opensource.org/licenses/mit-license.php>
	 * Copyright © 2014 Drakkashi.com
	 */

	public class Person extends Container{

		protected var current:Room,
					  gender:String;

		public function setGender(str:String):Boolean{
			if (!empty(str)){
				str = str.toLowerCase();
	
				if (str == "male" || str == "female")
					gender = str;
				else
					return false;
			}
			else
				gender = null;
			return true;
		}

		public function getGender():String{
			return gender;
		}

		public function currentRoom():Room{
			return current;
		}

		override public function setVar(id:String,val:*, ... args):String{
			if (id == "gender"){
				if (!setGender(String(val)))
					return 'Invalid gender "' + val + '".';
			}
			else
				return super.setVar(id,val);
			return null;
		}

		public function dropItem(... args):void{
			var item:Item = (toClass(args[0]) == Item ? args[0] : Item.getItem(args[0]));

			if (item){
				if (itemList.indexOf(item) >= 0 && currentRoom())
					currentRoom().giveItem(item);
				else if (itemList.indexOf(item) >= 0)
					item.remove();
			}
		}

		override public function getMethods():Array{
			return super.getMethods().concat(new Array("setGender","getGender","dropItem","moveTo","currentRoom"));
		}
	}
}