﻿package script{
	import fl.motion.easing.Back;

	/*
	 * AINE - Accelerated Interactive Narrator Engine
	 * @version 0.4.2 ALPHA
	 * @author Daniel Svejstrup Christensen
	 * @see http://www.drakkashi.com/aine/ for updates
	 * This software is released under the MIT License <http://www.opensource.org/licenses/mit-license.php>
	 * Copyright © 2014 Drakkashi.com
	 */

	public class _Event{
		
		private static var eventQueue:Array = new Array(),
						   destiny:Room;

		private var str:String,
					evt:String,
					enabled:Boolean,
					replace:Boolean;

		public function _Event(str:String, evt:String, enabled:Boolean, replace:Boolean = false){
			this.str = str;
			this.evt = evt;
			this.enabled = enabled;
			this.replace = replace;
		}
		
		public function getEvent():String{
			return evt;
		}
		
		public function getString():String{
			return str;
		}
		
		public function isEnabled():Boolean{
			return enabled;
		}
		
		public function getOverride():Boolean{
			return replace;
		}
		
		public function setOverride(b:Boolean):void{
			replace = b;
		}
		
		public function append(str:String):void{
			str += str;
		}
		
		public function toggle():void{
			enabled = !enabled;
		}
		
		public function enable():void{
			enabled = true
		}

		public function disable():void{
			enabled = false;
		}

		public function trigger():void{
			if (eventQueue.length > 0){
				eventQueue.splice(0,1);

				if (eventQueue.length > 0)
					eventQueue[0].trigger();
			}
			else if (destiny){
				Room.setCurrent(destiny);
				eventEnterRoom(destiny);
			}
		}

		public static function eventEnterRoom(room:Room):Boolean{
			return true;
		}

		public static function eventLeaveRoom(room:Room):Room{
			destiny = room;
			return (eventQueue.length > 0 ? null : destiny );
		}

		public static function clearDestiny():void{
			destiny = null;
		}
	}
}